<?php

/*
Plugin Name: Widget Changer
Plugin URI: http://maketecheasier.com/
Description: This plugin allows you to set a different widget for different pages 
Version: 1.1.3
Author: Damien Oh
Author URI: http://maketecheasier.com/about

Copyright 2007  Damien Oh  (email : damien@maketecheasier.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

$WidgetC_db_version = "1.1";
$table_name = $wpdb->prefix . "widgetC";

$WC_config = array ('allow_user_role' => "8",
'appear_on' => "post");

add_option('widget_changer', $WC_config, 'Settings for WP Widget Changer');
$WidgetC = get_option("widget_changer");

if(isset($_POST['check_widget_submit'])){
	$WidgetC['allow_user_role'] = $_POST['wc_user_level'];
	$WidgetC['appear_on'] = $_POST['appear_on'];
	update_option('widget_changer', $WidgetC);
}

register_activation_hook(__FILE__,'widget_db_install');
if($WidgetC['appear_on']=="post")
{
add_action('edit_post', 'add_widget_content');
add_action('publish_post', 'add_widget_content');
add_action('save_post', 'add_widget_content');
add_action('edit_page_form', 'add_widget_content');
add_action('edit_page_form', 'widget_input_form');
add_action('dbx_post_advanced', 'widget_input_form');
add_action('dbx_page_advanced', 'widget_input_form');
}
else if($WidgetC['appear_on']=="category")
{
add_action('edit_category_form', 'widget_input_form');
add_action('edit_category', 'add_widget_content');
add_action('create_category', 'add_widget_content');
}
add_action('plugins_loaded', 'widget_changer_init');
add_action('admin_menu', 'WC_add_option_page');


// ----------------------------------------- function --------------------------------------------------------


function widget_db_install () 
{  global $wpdb;
   global $WidgetC_db_version;
   global $table_name;
	
  
   if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
      
      $sql = "CREATE TABLE " . $table_name . " (
	  Post_ID mediumint(9) NOT NULL,
	  Post_Type TEXT NOT NULL,
	  Widget_Title TEXT NOT NULL,
	  Widget_Content LONGTEXT NOT NULL
	);";

      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      dbDelta($sql);
 
	  add_option("WidgetC_db_version", $WidgetC_db_version); 
   }
   
   $installed_ver = get_option( "WidgetC_db_version" );	
   if( $WidgetC_db_version != $installed_ver) {

      $sql = "CREATE TABLE " . $table_name . " (
	  Post_ID mediumint(9) NOT NULL,
	  Post_Type TEXT NOT NULL,
	  Widget_Title TEXT NOT NULL,
	  Widget_Content LONGTEXT NOT NULL
	);";

      require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
      dbDelta($sql);
	  $wpdb->query("UPDATE $table_name SET Post_Type='post' WHERE Post_Type=''");
      update_option("WidgetC_db_version", $WidgetC_db_version);
  }
 
}

function WC_add_option_page ()
{
	add_options_page('Widget Changer', 'Widget Changer', 8, basename(__FILE__), 'WC_option_page');
}
	
function WC_option_page ()
{
	global $WidgetC;
?>	<div class="wrap">
 <h2>Widget Changer Options</h2>
	<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>?page=widget_changer.php">
	<input type="hidden" name="check_widget_submit" value="1" />
	<p> Allow users with <select name="wc_user_level">
							<option value="8" <?php if($WidgetC['allow_user_role'] == 8) echo 'selected="selected"' ?>>Administrator</option>
							<option value="5" <?php if($WidgetC['allow_user_role'] == 5) echo 'selected="selected"' ?>>Editor</option>
							<option value="2" <?php if($WidgetC['allow_user_role'] == 2) echo 'selected="selected"' ?>>Author</option>
							<option value="1" <?php if($WidgetC['allow_user_role'] == 1) echo 'selected="selected"' ?>>Contributor</option>
							</select> privilege to add/edit widget </p>
							<hr/>
	<p>Configure your widget to appear on:</p>
	<p><input type="radio" name="appear_on" value="post" <?php if($WidgetC['appear_on']=="post") echo 'checked="checked"'; ?> /> specific posts/pages. This will allow you to set which widget to appear on each page.<br/>
	   <input type="radio" name="appear_on" value="category" <?php if($WidgetC['appear_on']=="category") echo 'checked="checked"'; ?> /> specific category. This will allow you to set which widget to appear on each category. <?php if($WidgetC['appear_on']=="category") echo '<a href="'.get_option('home').'/wp-admin/categories.php">Manage category widget here</a>';?></p>
	<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options') ?>" />
</p>
	</form>
	</div>
<?php }

function widget_input_form()
{	global $post,$wpdb,$table_name,$userdata,$WidgetC;

    get_currentuserinfo();
	$wc_user_level = $userdata->user_level;
	if($wc_user_level >= $WidgetC['allow_user_role']){	
	$type=$WidgetC['appear_on'];
	if($type=="post")
	{
		$post_id = $post;
		if (is_object($post_id)) {
		   	$post_id = $post_id->ID;
		}
	}
	else
	{	$post_id = $_GET['cat_ID']; 
	}
	$widget = $wpdb->get_row("SELECT * FROM $table_name WHERE Post_ID='$post_id' AND Post_Type='$type'");
	if(is_object($widget))
	{	$widget_title = $widget->Widget_Title;
		$widget_content = $widget->Widget_Content;
	}
	else
	{	$widget_title="";
		$widget_content="";
	} ?>	
			<SCRIPT LANGUAGE="JavaScript">
		<!-- Begin
		function countChars(field,cntfield) {
		cntfield.value = field.value.length;
		}
		//  End -->
		</script>
	<div class="dbx-b-ox-wrapper">
		<fieldset id="widgetchangerdiv" class="dbx-box">
			<div class="dbx-h-andle-wrapper">
		<h3 class="dbx-handle"><a style="color:white" target="__blank" href="http://maketecheasier.com/wordpress-plugins/wordpress-widget-changer">Widget Changer</a></h3>
			</div>
			<div class="dbx-c-ontent-wrapper">
		<div class="dbx-content">
	
	<input value="is_add_widget" type="hidden" name="is_add_widget" />
		<table>
		<tr>
		<td valign="top" align="right" width="30%"><strong>Widget Title</strong></td>
		<td><input type="text" value="<?php echo $widget_title; ?>" name="widget_title" size="60" /></td>
		</tr>
		</tr>
		<tr>
		<td valign="top" align="right"><strong>Widget Code</strong></td>
		<td><textarea id="add_widget" name="add_widget" rows="10" cols="58"><?php echo stripslashes($widget_content); ?></textarea></td>
		</tr>
		</table>
		<br/>
				</div>
			</div>
		</fieldset>
	</div><br/>
		<?php
		}
}


function add_widget_content($ID)
{	global $wpdb,$table_name,$WidgetC;

	if(isset($_POST['is_add_widget']))
	{	$widget_title = $_POST['widget_title'];
		$widget_content = $_POST['add_widget'];
		$type = $WidgetC['appear_on'];
		$result = $wpdb->get_row("SELECT * FROM $table_name WHERE Post_ID='$ID' AND Post_Type='$type'",ARRAY_N);
		if(count($result)==0)
			$result = $wpdb->query("INSERT INTO $table_name (Post_ID, Post_Type, Widget_Title, Widget_Content) VALUES ('$ID', '$type','$widget_title', '$widget_content')");
		else if(count($result) >0)
			$result = $wpdb->query("UPDATE $table_name SET Widget_Title='$widget_title', Widget_Content = '$widget_content' WHERE Post_ID = '$ID' AND Post_Type='$type'");
	}
	$wpdb->query("DELETE FROM $table_name WHERE Widget_Title='' AND Widget_Content=''");
	return $ID;
}

function widget_changer_init()
{		
	if ( !function_exists('register_sidebar_widget'))
		return; 
		
	function widget_changer($args)
	{	global $wpdb,$post,$table_name,$WidgetC;	
		$widget_title = "";
		$widget_content = "";
		$cat = "";
		extract($args);
		$type = $WidgetC['appear_on'];
		if(is_single() || is_page()){
			if($type=="post")
			{	$sql = "SELECT * FROM $table_name WHERE Post_ID='$post->ID' AND Post_Type='$type'";
				$widget = $wpdb->get_row($sql);
			}
			elseif($type=="category")
			{	foreach(get_the_category() as $category)
				{	
				$cat = $category->cat_ID;
				$sql = "SELECT * FROM $table_name WHERE Post_ID='$cat' AND Post_Type='$type'";
				$widget = $wpdb->get_row($sql);
				if($widget !=null) break;
				}				
			}
			if($widget != null){
				$widget_title = $widget->Widget_Title;
				$widget_content = $widget->Widget_Content;
				if($widget_content != ""){
					echo $before_widget;
					if($widget_title != "")
					{	echo $before_title . $widget_title . $after_title; 
					}
					echo $widget_content;
					echo $after_widget;	
				}
			}
		}
		
	}

	// This registers the widget. About time.
	register_sidebar_widget('Widget Changer', 'widget_changer');

}

?>
